Bug 1028662 - [RHCS 6.5]Split-brain issue with "fence_scsi result: error from agent"
[RHCS 6.5]Split-brain issue with "fence_scsi result: error from agent"
Status: CLOSED INSUFFICIENT_DATA
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: fence-agents (Show other bugs)
6.5
x86_64 Linux
unspecified Severity high
: rc
: ---
Assigned To: Marek Grac
Cluster QE
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-11-09 03:15 EST by zwei
Modified: 2014-09-08 21:30 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-11-20 12:41:33 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Logs and Configuration files (14.18 MB, application/x-rar)
2013-11-09 03:15 EST, zwei
no flags Details

  None (edit)
Description zwei 2013-11-09 03:15:05 EST
Created attachment 821857 [details]
Logs and Configuration files

Description of problem:
It is a two-node cluster: lin106094 & lin106095. I am simulating cluster heartbeat down in my testing evironment by using network link down operation.
When I shut down node lin106094’s heartbeat port (#ifdown eth1), it tried to clean lin106095’s SCSI reservation and never reboot itself even it was fenced by node lin106095. In my opinion, the high priority lin106095 should clean the SCSI reservation from lin106094, and lin106094 should reboot itself.

Version-Release number of selected component (if applicable):
RHEL6.5-20131024.1-Server-x86_64-DVD1.iso

How reproducible:

100%

Steps to Reproduce:
1.Build a two-node cluster with fence_scsi agent on EMC VNX array.
2.Excute ifdown command to shut down the heartbeat link.

Actual results:
Both node tried to clean the SCSI reservation. 
Node lin106095 success to do cleaning and fence node lin106094. 
Node lin106094 which is fenced by cluster don't reboot itself, and kept report "reservation conflict". So resource group can't be moved to remain node.

fenced[2596]: fence lin106095 dev 0.0 agent fence_scsi result: error from agent
fence_scsi: [error] main::do_verify_off: failed to verify 1 devices

Expected results:

The node which is fenced by cluster should crash and reboot itself.

Additional info:
<failoverdomain name="test_fd" ordered="1" restricted="1">
                                <failoverdomainnode name="lin106094" priority="2"/>
                                <failoverdomainnode name="lin106095" priority="1"/>
                 </failoverdomain>

Before heartbeat down:
[root@lin106095 ~]# sg_persist --in --read-keys --device=/dev/emcpowerc
  DGC       VRAID             0533
  Peripheral device type: disk
  PR generation=0xe0c, 2 registered reservation keys follow:
    0xe5d0001
0xe5d0002
After heartbeat down:
[root@lin106095 ~]# sg_persist --in --read-keys --device=/dev/emcpowerc
  DGC       VRAID             0533
  Peripheral device type: disk
  PR generation=0xe41, 1 registered reservation key follows:
    0xe5d0002

•	Kernel log on Node lin106094
Nov  7 02:26:56 lin106094 corosync[2278]:   [TOTEM ] A processor failed, forming new configuration.
Nov  7 02:26:56 lin106094 corosync[2278]:   [TOTEM ] The network interface is down.
Nov  7 02:26:58 lin106094 corosync[2278]:   [QUORUM] Members[1]: 2
Nov  7 02:26:58 lin106094 corosync[2278]:   [TOTEM ] A processor joined or left the membership and a new membership was formed.
Nov  7 02:26:58 lin106094 corosync[2278]:   [QUORUM] Members[2]: 1 2
Nov  7 02:26:58 lin106094 corosync[2278]:   [QUORUM] Members[2]: 1 2
Nov  7 02:26:58 lin106094 kernel: dlm: closing connection to node 1
Nov  7 02:26:58 lin106094 corosync[2278]:   [CPG   ] chosen downlist: sender r(0) ip(127.0.0.1) ; members(old:2 left:1)
Nov  7 02:26:58 lin106094 corosync[2278]:   [MAIN  ] Completed service synchronization, ready to provide service.
Nov  7 02:26:59 lin106094 fenced[2596]: fencing node lin106095
Nov  7 02:26:59 lin106094 kernel: GFS2: fsid=vnx_cluster:test_gfs2.0: jid=1: Trying to acquire journal lock...
Nov  7 02:26:59 lin106094 kernel: sd 6:0:0:2: reservation conflict
Nov  7 02:26:59 lin106094 kernel: sd 6:0:0:2: reservation conflict
Nov  7 02:26:59 lin106094 kernel: sd 5:0:0:2: reservation conflict
Nov  7 02:26:59 lin106094 kernel: sd 5:0:0:2: reservation conflict
Nov  7 02:26:59 lin106094 fenced[2596]: fence lin106095 dev 0.0 agent fence_scsi result: error from agent
Nov  7 02:26:59 lin106094 fenced[2596]: fence lin106095 failed
•	Fence_scsi log on lin106094  (/tmp/fence_scsi.log)
Nov  7 02:26:59 fence_scsi: [debug] main::do_preempt_abort (host_key=e5d0001, node_key=e5d0002, dev=/dev/emcpowerc)
Nov  7 02:26:59 fence_scsi: [debug] main::do_preempt_abort (err=99)
Nov  7 02:26:59 fence_scsi: [error] main::do_verify_off: failed to verify 1 devices
Nov  7 02:26:59 fence_scsi: [debug] failed to remove key e5d0002 from device /dev/emcpowerc
•	Kernel log on Node lin106095
Nov  7 02:26:57 lin106095 corosync[2344]:   [TOTEM ] A processor failed, forming new configuration.
Nov  7 02:26:59 lin106095 corosync[2344]:   [QUORUM] Members[1]: 2
Nov  7 02:26:59 lin106095 kernel: dlm: closing connection to node 1
Nov  7 02:26:59 lin106095 kernel: GFS2: fsid=vnx_cluster:test_gfs2.1: jid=0: Trying to acquire journal lock...
Nov  7 02:26:59 lin106095 corosync[2344]:   [TOTEM ] A processor joined or left the membership and a new membership was formed.
Nov  7 02:26:59 lin106095 corosync[2344]:   [CPG   ] chosen downlist: sender r(0) ip(10.10.11.103) ; members(old:2 left:1)
Nov  7 02:26:59 lin106095 corosync[2344]:   [MAIN  ] Completed service synchronization, ready to provide service.
Nov  7 02:26:59 lin106095 fenced[2650]: fencing node lin106094
Nov  7 02:26:59 lin106095 rgmanager[3657]: State change: lin106094 DOWN
Nov  7 02:26:59 lin106095 fenced[2650]: fence lin106094 success
Nov  7 02:27:00 lin106095 kernel: GFS2: fsid=vnx_cluster:test_gfs2.1: jid=0: Looking at journal...
Nov  7 02:27:00 lin106095 kernel: GFS2: fsid=vnx_cluster:test_gfs2.1: jid=0: Done
Nov  7 02:41:24 lin106095 qdiskd[2392]: Assuming master role
Nov  7 02:41:25 lin106095 qdiskd[2392]: Writing eviction notice for node 1
Nov  7 02:41:26 lin106095 qdiskd[2392]: Node 1 evicted
•	Fence_scsi log on lin106095
Nov  7 02:26:59 fence_scsi: [debug] main::do_preempt_abort (host_key=e5d0002, node_key=e5d0001, dev=/dev/emcpowerc)
Nov  7 02:26:59 fence_scsi: [debug] main::do_preempt_abort (err=0)

BTW, a little change has been made on /usr/sbin/fence_scsi#vi /usr/sbin/fence_scsi

sub get_devices_scsi ()
{
    my $self = (caller(0))[3];
    my @devices;

    opendir (\*DIR, "/sys/block/") or die "$!\n";
#  @devices = grep { /^sd/ } readdir (DIR);                                            #[This is the original macro]
    @devices = grep { /^sd/ | /^emcpower/ } readdir (DIR);           #[This is the change]
    closedir (DIR);

    return (@devices);
}
Comment 2 Marek Grac 2013-11-11 05:15:47 EST
@zwei:

Hi,

if I understand it correctly:
1) fence_scsi properly removes reservations as expected 
2) node that is a victim and can not access storage 
3) victim node is not rebooted

From my point of view this is a correct behaviour. fence_scsi can not reboot itself and external fencing device is required because otherwise we cannot guarantee that reboot was really done (e.g. in case of kernel panic).

Note You need to log in before you can comment on or make changes to this bug.